{$R+}
{$N+}
{$E+}
{$I+}
program horn;

var
  a,b,c,d : double; 
  p,k,n : integer;
  lambda_k, last_lambda : double;

type
  coefficient_rec = record
    a,b,c,d : double;
  end;
    
var
  coef_table : array[1..48] of coefficient_rec;
  i,j : integer;
  tab:text;

begin
  assign(output,''); rewrite(output);
  assign(input,''); reset(input);
  assign(tab,'coef.dat');
  {$I-}
  reset(tab);
  {$I+}
  if (IOresult<>0) then
    begin
      writeln('Cannot open COEF.DAT');
      halt;
    end;
  for i := 1 to 48 do
    begin
      with coef_table[i] do
        readln(tab,a,b,c,d);
    end;
  close(tab);
  write('Enter number of variables: ');
  readln(p);
  write('Enter sample size: ');
  readln(n);
  if (p>43) then  { for p>43, can do all roots...}
    j := p
  else            { .. otherwise only p-2 roots }
    j := p-2;
  last_lambda := 1;
  writeln(output);
  writeln(output);
  writeln(output,'Number of variables = ',p);
  writeln(output);
  writeln(output,'Sample size = ',n);
  writeln(output);
  writeln(output);
  writeln(output,'  k  ',' lambda[k] ');
  writeln(output,'-----','-----------');
  for k := 1 to j do
    begin
      a := coef_table[k].a;
      b := coef_table[k].b;
      c := coef_table[k].c;
      d := coef_table[k].d;
      lambda_k := exp(a + b*ln(n-1) + c*ln((p-k-1)*(p-k+2)/2) + 
                      d*ln(last_lambda));
      last_lambda := lambda_k;
      writeln(output,k:3,'  ',lambda_k:11:5);
    end;
  writeln;
  writeln('These lambda values are predicted parallel analysis (Horn, 1965)');
  writeln('results based on Allen and Hubbard''s (1986) simulation results.');
  writeln('Compare lambda[k] against the kTH eigenvalue obtained in a ');
  writeln('principal components analysis of standardized data.  The point');
  writeln('at which the obtained eigenvalues fall below these predicted values');
  writeln('indicates that the eigenvalue for that factor accounts for less ');
  writeln('variability than chance associations in a simulated experiment.');
  writeln('Generally, that eigenvalue or the previous one is chosen as the ');
  writeln('best indicator of the dimensionality of the matrix being analyzed.');
end.
